"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  identifier: true,
  entries: true,
  optional: true
};
exports.entries = void 0;
exports.identifier = identifier;
exports.optional = optional;
var fc = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("fast-check"));
Object.keys(fc).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === fc[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return fc[key];
    }
  });
});
var _registry = /*#__PURE__*/require("@traversable/registry");
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const Object_keys = globalThis.Object.keys;
/** @internal */
const Array_isArray = globalThis.Array.isArray;
/** @internal */
const isString = u => typeof u === 'string';
/** @internal */
const arrayOf = p => u => Array_isArray(u) && u.every(p);
/** @internal */
const has = (k, p) => u => !!u && typeof u === 'object' && Object.hasOwn(u, k) && p(u[k]);
const PATTERN = {
  identifier: /^[$_a-zA-Z][$_a-zA-Z0-9]*$/
};
function identifier(constraints) {
  return fc.stringMatching(PATTERN.identifier, constraints); //.filter((ident) => !(ident in KEYWORD))
}
const entries = (model, constraints) => fc.uniqueArray(fc.tuple(identifier(), model), {
  ...constraints,
  selector: ([k]) => k
});
exports.entries = entries;
function optional(model) {
  model[_registry.symbol.optional] = true;
  return model;
}
// /** @internal */
// type Keyword = keyof typeof Keyword
// const Keyword = {
//   break: "break", case: "case", catch: "catch", class: "class", const: "const",
//   continue: "continue", debugger: "debugger", default: "default", delete: "delete",
//   do: "do", else: "else", export: "export", extends: "extends", false: "false",
//   finally: "finally", for: "for", function: "function", if: "if", import: "import",
//   in: "in", instanceof: "instanceof", new: "new", null: "null", return: "return",
//   super: "super", switch: "switch", this: "this", throw: "throw", true: "true",
//   try: "try", typeof: "typeof", var: "var", void: "void", while: "while",
//   with: "with", let: "let", static: "static", yield: "yield",
// } as const satisfies Record<string, string>
//# sourceMappingURL=fast-check.js.map