import { URI } from '@traversable/registry';
import * as fc from './fast-check.js';
/** @internal */
const Array_isArray = globalThis.Array.isArray;
/** @internal */
const Object_assign = globalThis.Object.assign;
/** @internal */
const Object_keys = globalThis.Object.keys;
/** @internal */
const Object_fromEntries = globalThis.Object.fromEntries;
/** @internal */
const isComposite = u => Array_isArray(u) || u !== null && typeof u === 'object';
const NullaryArbitraryMap = {
  [URI.never]: /*#__PURE__*/fc.constant(void 0),
  [URI.void]: /*#__PURE__*/fc.constant(void 0),
  [URI.unknown]: /*#__PURE__*/fc.jsonValue(),
  [URI.any]: /*#__PURE__*/fc.jsonValue(),
  [URI.symbol]: /*#__PURE__*/fc.string().map(Symbol.for),
  [URI.null]: /*#__PURE__*/fc.constant(null),
  [URI.undefined]: /*#__PURE__*/fc.constant(undefined),
  [URI.boolean]: /*#__PURE__*/fc.boolean()
};
const BoundableArbitraryMap = {
  [URI.integer]: /*#__PURE__*/fc.integer(),
  [URI.number]: /*#__PURE__*/fc.float(),
  [URI.bigint]: /*#__PURE__*/fc.bigInt(),
  [URI.string]: /*#__PURE__*/fc.string()
};
export const is = u => {
  return !!u && typeof u === 'object'
  /**
   * Properties taken from the
   * [`Arbitrary` interface](https://github.com/dubzzz/fast-check/blob/main/packages/fast-check/src/check/arbitrary/definition/Arbitrary.ts)
   */ && 'generate' in u && 'shrink' in u && 'filter' in u && 'map' in u && 'chain' in u && 'canShrinkWithoutContext' in u;
};
//# sourceMappingURL=arbitrary.js.map