export * from 'fast-check';
import * as fc from 'fast-check';
import { symbol as Symbol } from '@traversable/registry';
/** @internal */
const Object_keys = globalThis.Object.keys;
/** @internal */
const Array_isArray = globalThis.Array.isArray;
/** @internal */
const isString = u => typeof u === 'string';
/** @internal */
const arrayOf = p => u => Array_isArray(u) && u.every(p);
/** @internal */
const has = (k, p) => u => !!u && typeof u === 'object' && Object.hasOwn(u, k) && p(u[k]);
const PATTERN = {
  identifier: /^[$_a-zA-Z][$_a-zA-Z0-9]*$/
};
export function identifier(constraints) {
  return fc.stringMatching(PATTERN.identifier, constraints); //.filter((ident) => !(ident in KEYWORD))
}
export const entries = (model, constraints) => fc.uniqueArray(fc.tuple(identifier(), model), {
  ...constraints,
  selector: ([k]) => k
});
export function optional(model) {
  model[Symbol.optional] = true;
  return model;
}
// /** @internal */
// type Keyword = keyof typeof Keyword
// const Keyword = {
//   break: "break", case: "case", catch: "catch", class: "class", const: "const",
//   continue: "continue", debugger: "debugger", default: "default", delete: "delete",
//   do: "do", else: "else", export: "export", extends: "extends", false: "false",
//   finally: "finally", for: "for", function: "function", if: "if", import: "import",
//   in: "in", instanceof: "instanceof", new: "new", null: "null", return: "return",
//   super: "super", switch: "switch", this: "this", throw: "throw", true: "true",
//   try: "try", typeof: "typeof", var: "var", void: "void", while: "while",
//   with: "with", let: "let", static: "static", yield: "yield",
// } as const satisfies Record<string, string>
//# sourceMappingURL=fast-check.js.map